# CI/CD Debugging Adventures 🧙‍♂️✨

Greetings, aspiring wizard! You've stumbled upon a magical repository filled with 5 CI/CD pipeline exercises, each containing enchanted misconfigurations and mischievous bugs. Your quest: to identify and vanquish these issues, ensuring that each pipeline runs smoothly and your magic flows unhindered.

## How to embark on your journey

1. **Fork the Repository**: Channel your inner wizard and fork this repo to your own GitLab project.
2. **Clone Your Fork**: Summon the repository to your local machine.
3. **Begin Debugging**: Let the debugging magic begin! 🧙‍♀️

Delve into the `.gitlab-ci.yml` file and explore the enchanted folders for each exercise. Start with **Exercise 1** and progress through to **Exercise 5**. Each task will challenge you with various magical dilemmas—syntax errors, misdirected paths, missing incantations, and faulty logic.

## Requirements for your mystical journey

* A **GitLab account** with permission to run pipelines.
* Basic knowledge of **CI/CD**, **Git**, and **YAML syntax** (even wizards need the basics!).
* (Optional) **Docker** installed locally if you wish to test your spells before casting them in the cloud.

## The Exercises You'll Conquer

1. **Linting** 🧹 – Banish misformated spells (code) and make them shine.
2. **Testing** 🔮 – Ensure your spells (tests) are cast correctly with perfect coverage.
3. **Building** ⚡ – Craft and containerize your magic into usable forms.
4. **Secrets** 🗝️ – Guard your most powerful incantations (secrets) securely.
5. **Docs** 📜 – Document your magical creations for others to understand and admire.

May your debugging prowess guide you through this adventure! 🧙‍♂️✨

***
